DECLARE SUB BlankUDT ()
DECLARE SUB DeleteSelected ()
DECLARE SUB GETCURSOR ()
DECLARE SUB Clone (X%, y%)
DECLARE SUB DoConsole ()
DECLARE SUB LoadUDT (path$, wld!)
DECLARE SUB SelectUnit (X!, y!)
DECLARE SUB SaveUDT (path$, wld!)
DECLARE SUB CreateMonster (X%, y%, Team%, Skill%, HP%, Name$, Mode%)
DECLARE SUB LoadMonsters ()
DECLARE SUB Lpalette ()
DECLARE SUB EXITSUB ()
DECLARE FUNCTION InMap% (X AS INTEGER, y AS INTEGER)
DECLARE SUB SaveBDT (file2$)


'$INCLUDE: 'cdm.bi' ' mainly for type definitions
' FutureTileEngine
'$INCLUDE: 'future.bi'

'$DYNAMIC

STACK (STACK / 2)
DIM SHARED mapchar(-1 TO 44, -1 TO 28) AS STRING * 1

'DEFSNG A-Z
DIM SHARED msgs$(24)
DIM SHARED grass(90)
DIM SHARED dirt(90)
DIM SHARED tree(90)
DIM SHARED tree2(90)
DIM SHARED stump(90)
DIM SHARED fire1(90)
DIM SHARED fire2(90)
DIM SHARED fire3(90)
DIM SHARED lastfire
DIM SHARED water(90)
DIM SHARED floor(90)
DIM SHARED cobble(90)
DIM SHARED ffield(90)
DIM SHARED brick(90)
DIM SHARED grind(90)
DIM SHARED flour(90)
DIM SHARED rock(90)
DIM SHARED furnace(90)
DIM SHARED anvil(90)
DIM SHARED bench(90)
DIM SHARED sign(90)
DIM SHARED fishspot(90)
DIM SHARED woodwall(90)
DIM SHARED grass2(90)
DIM SHARED rock2(90)
DIM SHARED rockW(90)
DIM SHARED rockw2(90)
DIM SHARED tiles(90)
DIM SHARED lava(90)
DIM SHARED snow(90)
DIM SHARED snowtree(90)

DIM SHARED player(90)
DIM SHARED playerBKG(90)
DIM SHARED pB(90)
DIM SHARED pC(90)
DIM SHARED pD(90)
DIM SHARED pE(90)
DIM SHARED FB(90)
DIM SHARED S1(90)
DIM SHARED bld(90)

DIM SHARED lastskill%
DIM SHARED lastname$
DIM SHARED lasticon%
DIM SHARED lastmode%

maxunits = 100
DIM SHARED unit(maxunits) AS Bunit

maxobs = 155
DIM SHARED obj(maxobs) AS ObjectType
DIM SHARED Skill(14) AS SkillType
DIM SHARED plot(100) AS PlotType

DIM SHARED monst(40) AS MonsterType

'DimShareds
DIM SHARED lbl$(40)
DIM SHARED lblX(40) AS SINGLE
DIM SHARED lblY(40) AS SINGLE
DIM SHARED lblM(40) AS SINGLE
DIM SHARED lblC(40) AS SINGLE
DIM SHARED s!(359)
DIM SHARED C!(359)
DIM SHARED BrushSize%
DIM SHARED EditMode%
DIM SHARED SELUNIT%

CONST pi = 3.141592654#
FOR i = 0 TO 359
   s!(i) = SIN(i * (pi / 180))
   C!(i) = COS(i * (pi / 180))
NEXT
RANDOMIZE TIMER

Set640x480 8
SetMaskColor 0
Future.CLS 0



IF IsXMSInstalled THEN
 'MSG "XMS installed"

 handle% = AllocateXMS(20480)             '32Xx32Yx20 pix =   20 KB
 Future.DefineXMSArray 32, 32, handle%

 csets% = AllocateXMS(128850)               '15Xx15Yx39  pix =126 KB
 Future.DefineXMSArray 15, 15, csets%
 icons% = AllocateXMS(204800)             '32Xx32Yx200 pix =  200 KB
 Future.DefineXMSArray 32, 32, icons%
 mdgs% = AllocateXMS(123300)                 '5x5x41          = 1 KB
 Future.DefineXMSArray 5, 5, mdgs%
 sprs% = AllocateXMS(127250)                '15x15x23=5250    124 KB
 Future.DefineXMSArray 15, 15, sprs%
 size64x% = AllocateXMS(40970)                '64x64x10   4.8
 Future.DefineXMSArray 64, 64, size64x%


 DIM SHARED mouse%
 mouse% = AllocateXMS(300)
 DIM SHARED mouseBK%
 mouseBK% = AllocateXMS(300)

                                                      'TOTAL: 471 KB
ELSE
 MSG "XMS FAILED"
 BEEP
 SLEEP
END IF

Primary% = 0
Secondary% = 1

Future.MouseOFF

FOR i = 1 TO 14
 Skill(i).Level = 1
 Skill(i).amt = 1
NEXT i

world$ = "maps\world 1.bd3"
tileset$ = "tileset.dat"
dmaps = 0
Xscroll% = 0
Yscroll% = 0
playerno = 1
world = 1
'INPUT "startmode:", startmode
Future.CLS 0

LoadTiles

LoadMonsters
ViewPage Secondary%
SetPage Secondary%
Future.CLS 0
SetPage Primary%
Future.LoadBMP "data\itr.bmp", 0, 0
ViewPage Primary%

FOR i = 1 TO 1600
 jkl$ = INKEY$
 IF jkl$ <> "" THEN
  IF jkl$ = "1" THEN startmode = 1 ELSE startmode = 0
  EXIT FOR
 END IF
NEXT i
BrushSize% = 1
Future.CLS 0
'INITGAME
Lpalette
MSG "Welcome to the Cadisman World Editor"
IF EditMode% = 0 THEN Future.MouseOFF
schar$ = "G"
GETCURSOR
Drawmap 0, 1, 0, 0
DO
 IF EditMode% = 0 THEN Future.XMSPUT INT(mx% / 15) * 15, INT(my% / 15) * 15, mouseBK%
 Future.UpdateMouse
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
 IF EditMode% = 0 THEN Future.XMSGET INT(mx% / 15) * 15, INT(my% / 15) * 15, INT(mx% / 15) * 15 + 16, INT(my% / 15) * 15 + 16, mouseBK%
IF EditMode% = 0 THEN
  Future.XMSPUT INT(mx% / 15) * 15, INT(my% / 15) * 15, mouse%
  IF Future.MouseB% = 2 THEN
   DO: LOOP UNTIL Future.MouseB% = 0
   'schar$ = mapchar$(mxs, mys)
    MSG STR$(mxs + Xscroll%) + STR$(mys + Yscroll%)
    Future.XMSPUT INT(mxs - 1) * 15, INT(mys - 1) * 15, mouseBK%
    SetPage 2
    schar$ = CHR$(Future.POINT(mxs + Xscroll%, mys + Yscroll%))
    GETCURSOR
  END IF
  IF Future.MouseB% = 1 THEN
   IF mx% < 600 THEN
    IF schar$ = "" THEN schar$ = "G"
    SetPage 2
    Future.FILLBOX mxs + Xscroll%, mys + Yscroll%, mxs + Xscroll% - BrushSize% + 1, mys + Yscroll% - BrushSize% + 1, ASC(schar$)
    SetPage Primary%
    IF BrushSize% = 1 THEN
     Drawmap currentmap, 2, mxs + Xscroll%, mys + Yscroll%
    ELSE
     FOR X = 0 TO BrushSize% - 1
      FOR y = 0 TO BrushSize% - 1
       Drawmap currentmap, 2, mxs + Xscroll% - X, mys + Yscroll% - y
      NEXT y
     NEXT X
    END IF
    Future.XMSGET INT(mx% / 15) * 15, INT(my% / 15) * 15, INT(mx% / 15) * 15 + 16, INT(my% / 15) * 15 + 16, mouseBK%
   ELSE
    FOR y = 1 TO 6
     x2 = 604
     y2 = (y * 36) + 200
     IF Future.MouseX% > x2 AND Future.MouseX% < x2 + 32 THEN
      IF Future.MouseY% > y2 AND Future.MouseY% < y2 + 32 THEN 'globalY(currentmap + 0), ASC(schar$)
       vuBoxState = 1
       vuBoxNo = y
       'ViewTabs
      END IF
     END IF
    NEXT y
   END IF' if mx<600
  END IF
ELSE
 IF Future.MouseB% = 1 THEN
  DO: LOOP UNTIL Future.MouseB% = 0
  SelectUnit mxs - 1, mys - 1
  Drawmap 0, 1, 0, 0
  MSG "selected #" + STR$(SELUNIT%) + " from" + STR$(mxs) + STR$(mys)
 END IF
END IF
  HMapEditKeys
  DrawGuys
LOOP

REM $STATIC
SUB BlankUDT
 FOR i = 1 TO maxunits
  unit(i) = unit(0)
 NEXT i
END SUB

SUB Clone (X%, y%)
 FOR i = 2 TO 100
  IF unit(i).HP = 0 OR unit(i).Rank = -1 THEN
   unit(i) = unit(SELUNIT%)
   unit(i).X = X%
   unit(i).y = y%
   created = 1
   EXIT FOR
  END IF
 NEXT i
END SUB

REM $DYNAMIC
DEFINT A-Z
SUB CreateMonster (X, y, Team, Skill, HP, Name$, Mode)
 FOR i = 2 TO 100
  IF unit(i).HP = 0 OR unit(i).Rank = -1 THEN
   IF HP = 0 THEN HP = monst(Skill).HP
   found = 1
   unit(i).X = X
   unit(i).y = y
   'unit(I).map = WhichMap(X, Y)
   unit(i).Team = Team
   unit(i).Rank = 17
   unit(i).Skill = Skill' monster type
   unit(i).HP = HP
   unit(i).THP = HP
   unit(i).Spd = monst(Skill).Spd
   unit(i).icon = monst(Skill).icon
   unit(i).Name$ = Name$
   unit(i).Mode = Mode
   created = 1
   EXIT FOR
  END IF
 NEXT i
END SUB

REM $STATIC
DEFSNG A-Z
SUB DeleteSelected
   i = SELUNIT%
   unit(i).X = -1
   unit(i).y = -1
   'unit(I).map = WhichMap(X, Y)
   unit(i).Team = 0
   unit(i).Rank = -1
   unit(i).Skill = 0
   unit(i).HP = 0
   unit(i).THP = 0
   unit(i).Spd = 0
   unit(i).icon = 0
   unit(i).Name$ = ""
   unit(i).Mode = 0
   DrawGuys
END SUB

SUB DoConsole
   MINPUT console$, "->"
   SELECT CASE console$
    CASE "lbl"
     MSG "Place New Label"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
     MINPUT lbl$, "Label:"
     MINPUT lblCa$, "Label:"
     lblC = VAL(lblCa$)
     OPEN "data\labl" + STR$(world) + ".dat" FOR APPEND AS #1
      WRITE #1, lbl$, X1, Y1, lblC, 0
     CLOSE
    CASE "info"
     MSG "INFO"
     MSG "mapudt - saves current world udt to maps\"
     MSG "plyudt - saves current world udt to player\ (Caution, player must exist)"
     MSG "blkudt - clears all units & plots,then saves blank world udt to maps\"
     MSG "clrudt - clears all units"
     
    CASE "clrudt"
     BlankUDT
    CASE "mapudt"
     SaveUDT "maps\", world
    CASE "blkudt"
     FOR i = 2 TO 100
      unit(i).Rank = -1
     NEXT i
     SaveUDT "maps\", world
    CASE "file"
     MINPUT a$, "File:"
     world$ = "maps\" + a$ + ".bd3"
     BlankUDT
     LoadMaps world$
    CASE "monster"
     MSG "Place New Monster"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)

     MINPUT a$, "Type:"
     lastskill% = VAL(a$)
     MINPUT a$, "Name:"
     lastname$ = a$
     MINPUT a$, "Mode:"
     lastmode% = VAL(a$)
     CreateMonster INT(X1), INT(Y1), 2, lastskill%, 0, lastname$, lastmode%
     MSG "Use UDTEDIT to edit this unit properly"

    CASE "unit"
     FOR i = 1 TO maxunits
      IF unit(i).HP = 0 OR unit(i).Rank = -1 THEN
       iNewUnit% = i
       EXIT FOR
      END IF
     NEXT i

     MSG "Place New unit"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)

     unit(iNewUnit%).X = X1
     unit(iNewUnit%).y = Y1

     MINPUT a$, "Rank:"
     unit(iNewUnit%).Rank = VAL(a$)
     MINPUT a$, "Name:"
     unit(iNewUnit%).Name = a$
     MINPUT a$, "Icon:"
     unit(iNewUnit%).icon = VAL(a$)
     unit(iNewUnit%).HP = 10
     unit(iNewUnit%).THP = 10
     MSG "Use UDTEDIT to edit this unit properly"
    CASE "plot"
     MSG "place left-upper..."
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)
 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... place right-lower"
 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   x2 = mxs + mpx
   y2 = mys + mpy
   EXIT DO
  END IF
 LOOP
    MSG STR$((X1 - x2) * (Y1 - y2))
    MINPUT o$, "Owner#:"
    MINPUT C$, "Cost$#:"
    CLOSE : OPEN "data\plt" + STR$(world) + ".dat" FOR APPEND AS #1
     WRITE #1, X1, Y1, x2, y2, VAL(o$), VAL(C$)
    CLOSE
  CASE "mapedit"
   IF Mapedit = 1 THEN Mapedit = 0 ELSE Mapedit = 1
  CASE "warp"
   MINPUT C$, "map 1-100:"
   currentmap = VAL(C$)
   Drawmap currentmap, 1, 0, 0
  CASE "ghost"
   INPUT "ghost:", ghost
  CASE "tile"
   INPUT "tileset:", tileset$
  CASE "save"
  INPUT " Recompile?(r)=yes", rd$
  IF rd$ = "r" THEN
  INPUT " File:", file2$
  IF file2$ = "" THEN
   PRINT " Recompile as world "; world; "?(r)=yes";
   INPUT rd2$
   IF rd2$ = "r" THEN file2$ = "maps\world" + STR$(world) + ".bd2"
  END IF

  CLOSE
  OPEN file2$ FOR OUTPUT AS #1
  WRITE #1, tileset$
  FOR mapno = 1 TO 100
   map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
   OPEN map$ FOR INPUT AS #2
    FOR i = 1 TO 13
     INPUT #2, line$
     PRINT #1, line$
    NEXT i
   CLOSE #2

   LOCATE 1, 1
   PRINT mapno; "%"
   NEXT mapno
   PRINT " Press any key to continue..."
   Pause
   Drawmap currentmap, 1, 0, 0
  END IF
  CASE "q"
   INPUT "Type:(e.g. goblin,eman1)", Type$
   INPUT "Name:(optional)", Name$
   INPUT "HP(optional)", HP
   IF HP = 0 THEN HP = 10
   CLOSE
   MSG " Place AI " + Type$
   DO
    MouseStatus Lb%, Rb%, xm%, ym%: MouseShow
    MouseRange 1, 1, 640, 480
   LOOP UNTIL Lb% = -1
   X = INT((xm% / 2) / 15) + 1
   y = INT(ym% / 15) + 1
   MSG " AT " + STR$(X) + STR$(y)
   OPEN "data\quest 1.dat" FOR APPEND AS #1
    WRITE #1, Type$, X, y, currentmap, HP, 1, Name$, world
   CLOSE

   Drawmap currentmap, 1, 0, 0
  CASE "addtile"
   'NewTile


  CASE "vumap"
   Future.MouseOFF

   FOR mapno = 1 TO 100
   map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
   CLOSE
   OPEN map$ FOR INPUT AS #1
   X = 0
    DO UNTIL EOF(1)
    X = X + 1
    INPUT #1, line$
    FOR i = 1 TO LEN(line$)
     ch$ = MID$(line$, i, 1)
     Future.PSET i + M, X + m2, ASC(ch$) + 0
    NEXT i
   LOOP
   CLOSE
   M = M + 40
   IF RIGHT$(STR$(mapno), 1) = "0" THEN
    M = 0
    m2 = m2 + 25
   END IF
   NEXT mapno
   IF EditMode% = 1 THEN Future.MouseOn
   DO
    Future.UpdateMouse
    xm% = Future.MouseX%
    ym% = Future.MouseY%
    IF Future.MouseB% = 1 THEN
     Future.FILLBOX xm% - 1, ym% - 1, xm% - sz, ym% - sz, stc + 0
    END IF
   jkl$ = INKEY$
   SELECT CASE jkl$
    CASE "."
     MINPUT ch$, "Char:"
     MINPUT conc$, "Concentration:"
     conc = VAL(conc$)
     FOR i = 1 TO conc
      Future.PSET INT(RND * 400), INT(RND * 250), ASC(ch$)
     NEXT i
    CASE CHR$(27)
  MINPUT rd$, " Save?(y=yes bd2) (3=yes bd3)"
  IF rd$ = "y" OR rd$ = "3" THEN
   MINPUT file2$, " File:"
   IF rd$ = "3" THEN
    'PRINT "Saved as bd3 on " + DATE$ + TIME$
    xts = 40
    yts = 25
   ELSE
    xts = 21
    yts = 13
   END IF
   X = 0
   M = 0
   m2 = 0
   Future.MouseOFF
   CLOSE
   OPEN file2$ FOR OUTPUT AS #1
    WRITE #1, tileset$
    FOR mapno = 1 TO 100
     y = 0
     FOR X = 1 TO yts
      y = y + 1
      line$ = ""
       FOR i = 1 TO xts
        ac = Future.POINT(i + M, y + m2)
        IF ac < 1 OR ac > 254 THEN ac = ASC("G")
        line$ = line$ + CHR$(ac)
       NEXT i
      WRITE #1, line$
     NEXT X
     M = M + xts
     IF RIGHT$(STR$(mapno), 1) = "0" THEN
      M = 0
      m2 = m2 + yts
     END IF
    NEXT mapno
   Future.MouseOFF
  END IF
     Drawmap currentmap, 1, 0, 0
     EXIT DO
    CASE "-"
     sz = sz + 1
    CASE "="
     sz = sz - 1
    CASE ELSE
     IF jkl$ <> "" THEN
      stc = ASC(jkl$)
     END IF
   END SELECT
   LOOP
  CASE "newmap"
   'LoadWorld "maps\blank.bd2"
  CASE "world"
   MINPUT a$, "World:"
   world = VAL(a$)
   world$ = "maps\world" + STR$(world) + ".bd3"
   currentquest = world
   BlankUDT
   LoadUDT "maps\", world
   LoadMaps world$
  CASE "vutemp"

   FOR X = 1 TO 21
    FOR y = 1 TO 13
     PSET (X, y), ASC(mapchar$(X, y))
    NEXT
   NEXT
   Pause
  END SELECT

END SUB

REM $DYNAMIC
SUB DrawGuys
 FOR i = 1 TO maxunits
  IF unit(i).HP > 0 THEN
   IF unit(i).THP = 0 THEN unit(i).THP = 1
'   unit(i).map = WhichMap(INT(unit(i).X), INT(unit(i).y))
   IF InMap%(INT(unit(i).X), INT(unit(i).y)) THEN
     ux = unit(i).X - INT(Xscroll%) ' previously was checking with mapglobalX
     uy = unit(i).y - INT(Yscroll%)
     IF SELUNIT% = i THEN Future.BOX ux * 15, uy * 15, ux * 15 + 15, uy * 15 + 15, 14
     SELECT CASE unit(i).Rank
      CASE 20
       ' moooooo
       Future.XMSArrayPut ux * 15, uy * 15, sprs%, 2
      CASE 22
       ' buuuurk buk buk buk
       Future.XMSArrayPut ux * 15 + 1, uy * 15 + 1, sprs%, 3
      CASE 19
       ' fire
        iconP% = unit(i).Tx
        Future.XMSArrayPut ux * 15, uy * 15, sprs%, iconP%
      CASE 0
       IF i = selu THEN
        Future.BOX ux * 15, uy * 15 + 1, ux * 15 + 14, uy * 15 + 14, 9
        Future.FILLBOX ux * 15 + 1, uy * 15, ux * 15 + 14, uy * 15 + 1, 4
        Future.FILLBOX ux * 15 + ((unit(i).HP / unit(i).THP) * 14), uy * 15, ux * 15, uy * 15 + 1, 2
       END IF
       Future.PUT ux * 15 + 4, uy * 15, pD()
      CASE 1
    '   IF I = selu THEN
    '    Future.BOX ux * 15, uy * 15 + 1, ux * 15 + 14, uy * 15 + 14, 9
    '    Future.FILLBOX ux * 15 + 1, uy * 15, ux * 15 + 14, uy * 15 + 1, 4
    '    Future.FILLBOX ux * 15 + ((unit(I).HP / unit(I).THP) * 14), uy * 15, ux * 15, uy * 15 + 1, 2
    '   END IF
       Future.PUT ux * 15 + 3, uy * 15, player()
      CASE 2
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, 5
      CASE 3
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, 4
      CASE 4
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 18
      CASE 10
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 19
      CASE 98
       Future.XMSArrayPut ux * 15 - 15, uy * 15 - 15, icons%, 153
      CASE 25
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, unit(i).icon
      CASE 5
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 12
      CASE 6
       Future.XMSArrayPut ux * 15 + 2, uy * 15, sprs%, 11
      CASE 17
       ' monster
       SELECT CASE monst(unit(i).Skill).Size
        CASE 1
         Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, unit(i).icon
        CASE 2
         Future.XMSArrayPut ux * 15 + 1, uy * 15, icons%, unit(i).icon
        CASE 4
         Future.XMSArrayPut ux * 15 + 1, uy * 15, size64x%, unit(i).icon
       END SELECT

      CASE ELSE
       Future.XMSArrayPut ux * 15 + 1, uy * 15, sprs%, unit(i).icon
     END SELECT
   END IF
   END IF' on currentmap
 NEXT i
END SUB

SUB Drawmap (mapno, Mode, tileX, tileY)
 
Future.MouseOFF
 'SetPage Secondary%
 gmx = MapGlobalX(currentmap + 0)
 gmy = MapGlobalY(currentmap + 0)


 IF Mode = 2 THEN GOSUB tileonly


 map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
 
   'mapchar$(i, y) = char$
 MSG ""
tileonly:
  i = 0
  FOR X1 = 1 + Xscroll% TO 40 + Xscroll%
   i = i + 1
   y = 0
  FOR Y1 = 1 + Yscroll% TO 25 + Yscroll%
   y = y + 1
   IF Mode = 2 THEN
    i = tileX - Xscroll%
    y = tileY - Yscroll%
        'char$ = mapchar$(i, Y)
        '  x2 = i + gmx - 1
        '  y2 = y + gmy - 1
    char$ = CHR$(GROUND(tileX - 1, tileY - 1))
    IF mapno < 0 THEN
     char$ = CHR$(-mapno)
     i = 1
     y = 1
     MSG STR$(-mapno) + CHR$(-mapno)
    END IF
   ELSE
    SetPage 2
    C = Future.POINT(X1, Y1)
    IF C < 1 OR C > 255 THEN C = 1
    char$ = CHR$(C)
    SetPage Secondary%
   END IF
   SELECT CASE char$
    CASE "G"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), grass()
    CASE "D"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), dirt()
    CASE "t"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), tree()
    CASE "{"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), tree2()
    CASE "^"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), stump()
    CASE "f"
     SELECT CASE lastfire
      CASE 1
       Future.PUT ((i - 1) * 15), ((y - 1) * 15), fire1()
      CASE 2
       Future.PUT ((i - 1) * 15), ((y - 1) * 15), fire2()
      CASE ELSE
       Future.PUT ((i - 1) * 15), ((y - 1) * 15), fire3()
     END SELECT
     IF lastfire = 3 THEN lastfire = 0
     lastfire = lastfire + 1
    CASE "w"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), water()
    CASE "/"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), floor()
    CASE "C"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), cobble()
    CASE "F"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), ffield()
    CASE "b"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), brick()
    CASE "g"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), grind()
    CASE "@"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), flour()
    CASE "r", "", "", "", "", "", "", "", ""
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), rock()
     SELECT CASE char$
      CASE "r"
        Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 6, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 7, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 185, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 170, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 14, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 176, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 144, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 3, -1
      CASE ""
       Future.LINE ((i - 1) * 15), ((y - 1) * 15 + 14), ((i - 1) * 15 + 14), ((y - 1) * 15 + 14), 15, -1
     END SELECT
    CASE "j"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), furnace()
    CASE "a"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), anvil()
    CASE "|"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), bench()
    CASE "S"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), sign()
    CASE "y"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), fishspot()
    CASE "l"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), woodwall()
    CASE "H"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), grass2()
    CASE "q"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), rock2()
    CASE "u"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), rockW()
    CASE "T"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), tiles()
    CASE "e"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), lava()
    CASE "E"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), snow()
    CASE "i"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), snowtree()
    CASE "v"
     Future.PUT ((i - 1) * 15), ((y - 1) * 15), rockw2()
    CASE IS > CHR$(128)
     Future.XMSArrayPut ((i - 1) * 15), ((y - 1) * 15), csets%, (ASC(char$) - 128)
    CASE ELSE
     IF char$ <> "" THEN
      'LINE ((i - 1) * 15), ((Y - 1) * 15)-((i - 1) * 15 + 14, (Y - 1) * 15 + 14), 0, BF
     Future.XMSArrayPut ((i - 1) * 15), ((y - 1) * 15), csets%, 34
     END IF
   END SELECT
   IF Mode = 2 THEN
    IF mapno < 0 THEN SetPage Primary%
    IF EditMode% = 1 THEN Future.MouseOn
    EXIT SUB
   END IF
  NEXT Y1
  NEXT X1
 'LOOP
 CLOSE ff
 ff = FREEFILE
  OPEN "data\labl" + STR$(world) + ".dat" FOR APPEND AS #ff: CLOSE ff
  OPEN "data\labl" + STR$(world) + ".dat" FOR INPUT AS #ff
  DO UNTIL EOF(ff)
   INPUT #ff, M, X, y, C, t$
   IF InMap%(X + 0, y + 0) THEN
    Future.PRINT (X - gmx) * 15, (y - gmy) * 15, t$, C + 0, -1
   END IF
  LOOP
 CLOSE #ff
 IF Mapedit = 0 THEN DrawGuys
' MSG STR$(Xscroll%) + STR$(Yscroll%)
 SWAP Secondary%, Primary%
 SetPage Primary%
 ViewPage Primary%
 IF EditMode% = 1 THEN Future.MouseOn
END SUB

REM $STATIC
SUB EXITSUB
 ReSetScreen
 DeallocateXMS handle%
 DeallocateXMS sprs%
 DeallocateXMS csets%
 DeallocateXMS mdgs%
 DeallocateXMS mouse%
 DeallocateXMS mouseBK%
 END
END SUB

SUB GETCURSOR
 SetPage Secondary%
 Future.FILLBOX 0, 0, 30, 30, 0
 Drawmap -ASC(schar$), 2, 0, 0
 Future.BOX 1, 1, 15, 15, 0
 Future.BOX 2, 2, 14, 14, 4
 Future.BOX 3, 3, 13, 13, 12
 Future.XMSGET 1, 1, 15, 15, mouse%
 'SLEEP
 SetPage Primary%
 'ViewPage Primary%
 mx% = Future.MouseX%
 my% = Future.MouseY%
 Future.XMSGET INT(mx% / 15) * 15, INT(my% / 15) * 15, INT(mx% / 15) * 15 + 16, INT(my% / 15) * 15 + 16, mouseBK%
END SUB

REM $DYNAMIC
FUNCTION GROUND (X, y)
'Future.MouseOff
 SetPage 2
 C = Future.POINT(X + 1, y + 1)
 IF C < 1 OR C > 255 THEN C = 1
 GROUND = C
 SetPage Primary%
'Future.MouseOn
END FUNCTION

FUNCTION GuyAtSqr (X, y)
FOR i = 1 TO 100' 100 is THE max number of units... ever
 IF unit(i).HP > 0 THEN
  IF unit(i).X = X AND unit(i).y = y THEN
   GuyAtSqr = i
  END IF
 END IF
NEXT i
END FUNCTION

SUB HMapEditKeys
 jkl$ = INKEY$
 SELECT CASE jkl$
  CASE "s"
   i = SELUNIT%
   Future.PRINT 20, 20 + y, "#:" + STR$(i), 15, 0: y = y + 18
   Future.PRINT 20, 20 + y, "Name:" + unit(i).Name$, 15, 0: y = y + 18
   Future.PRINT 20, 20 + y, "Rank:" + STR$(unit(i).Rank), 15, 0: y = y + 18
   Future.PRINT 20, 20 + y, "Skill:" + STR$(unit(i).Skill), 15, 0: y = y + 18
   Future.PRINT 20, 20 + y, "Mode:" + STR$(unit(i).Mode), 15, 0: y = y + 18
   Future.PRINT 20, 20 + y, "Speed:" + STR$(unit(i).Spd), 15, 0: y = y + 18
  CASE "m"
     MSG "Move unit to new position..."
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)
    unit(SELUNIT%).X = X1
    unit(SELUNIT%).y = Y1
  CASE "n"
     MSG "Place same Monster"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)

 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)

     CreateMonster INT(X1), INT(Y1), 2, lastskill%, 0, lastname$, lastmode%
  CASE "c"
     MSG "Clone unit"
     mpx = MapGlobalX(currentmap + 0)
     mpy = MapGlobalY(currentmap + 0)
 DO
  Future.UpdateMouse
  IF Future.MouseB% = 1 THEN
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 0
   mx% = Future.MouseX%
   my% = Future.MouseY%
   mxs = INT(mx% / 15) + 1
   mys = INT(my% / 15) + 1
   X1 = mxs + mpx
   Y1 = mys + mpy
   EXIT DO
  END IF
 LOOP
   MSG "done... Unit is at " + STR$(X1) + STR$(Y1)
   Clone INT(X1), INT(Y1)

  CASE "1"
   BrushSize% = 1
  CASE "2"
   BrushSize% = 2
  CASE "3"
   BrushSize% = 3
  CASE "4"
   BrushSize% = 4
  CASE " "
   IF EditMode% = 1 THEN EditMode% = 0 ELSE EditMode% = 1
   Drawmap 0, 1, 0, 0
  CASE "v"
   ViewPage 2
   DO
    Future.UpdateMouse
   LOOP UNTIL Future.MouseB% = 1
   Xscroll% = Future.MouseX%
   Yscroll% = Future.MouseY%
   SLEEP
   ViewPage Primary%
  CASE CHR$(0) + "I"
   schar$ = CHR$(ASC(schar$) + 1)
   MSG schar$ + " selected"
  CASE CHR$(0) + "Q"
   schar$ = CHR$(ASC(schar$) - 1)
   MSG schar$ + " selected"
  CASE CHR$(0) + "S"
   DeleteSelected
   Drawmap 1, 1, 0, 0
  CASE "q"
   Mapedit = 0
  CASE CHR$(27)
  MINPUT file2$, "Save as:"
   IF file2$ <> "" THEN
    SaveBDT file2$
    MSG " MAP SAVED: Press any key to continue..."
    Pause
    Drawmap currentmap, 1, 0, 0
   ELSE
    EXITSUB
   END IF
   MSG "Its is strongly recommended that you reload the map"
'   EXITSUB
  CASE CHR$(0) + "K"
     Xscroll% = Xscroll% - 20
     currentmap = currentmap - 1
     Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "M"
      Xscroll% = Xscroll% + 20
      currentmap = currentmap + 1
      playerX = 1
      Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "H"
     Yscroll% = Yscroll% - 12
     currentmap = currentmap - 10
     playerY = 12 * 15
     Drawmap currentmap, 1, 0, 0
  CASE CHR$(0) + "P"
     Yscroll% = Yscroll% + 12
     currentmap = currentmap + 10
     playerY = 1
     Drawmap currentmap, 1, 0, 0
  CASE "!"
   MINPUT a$, ""
   'DoConsole a$
  CASE "`"
   DoConsole
  CASE ELSE
   IF jkl$ <> "" THEN
    schar$ = jkl$
    mx% = Future.MouseX%
    my% = Future.MouseY%
    mxs = INT(mx% / 15) + 1
    mys = INT(my% / 15) + 1
    Future.XMSPUT INT(mxs - 1) * 15, INT(mys - 1) * 15, mouseBK%
    GETCURSOR
   END IF
 END SELECT

END SUB

REM $STATIC
DEFINT A-Z
SUB INITGAME
ViewPage Primary%
SetPage Primary%
Future.CLS 0
Future.LoadBMP "data\load.bmp", 0, 0
Future.PRINT 50, 300, "Loading Cadisman...", 15, 0
market! = 0
LoadUDT "maps\", 1
Future.PRINT 50, 260, "Loading " + world$, 155, 0
SetPage Secondary%
'LoadObs
LoadMaps world$
'LoadSpr "man1.spr", player()
Lpalette
SetPage Primary%
 'ChooseClothes
SetPage Secondary%
'LoadSpr "iron.tdt", pB(), 0, 0
'LoadSpr "eman3.spr", pC(), 0, 0
'LoadSpr "man2.spr", pD(), 0, 0
'LoadSpr "cplt.spr", pE(), 0, 0
'LoadSpr "stone1.spr", S1(), 0, 0
'LoadSpr "fire_B.spr", FB(), 0, 0
'LoadSpr "blood.spr", bld(), 0, 0
SetPage Primary%
ViewPage Primary%
Drawmap 1, 0, 0, 0
selu = 1
Nptcls = 0
END SUB

REM $DYNAMIC
DEFSNG A-Z
FUNCTION InMap% (X AS INTEGER, y AS INTEGER)
InMap% = 0
IF X% >= Xscroll% AND X% <= Xscroll% + 39 THEN
 IF y% >= Yscroll% AND y% <= Yscroll% + 24 THEN
  InMap% = -1
 END IF
END IF
END FUNCTION

REM $STATIC
DEFINT A-Z
'
SUB LoadLabels
 CLOSE
 FOR i = 1 TO 50
  lbl$(i) = ""
 NEXT i
 OPEN "data\labl" + STR$(world) + ".dat" FOR APPEND AS #1
 CLOSE
 OPEN "data\labl" + STR$(world) + ".dat" FOR INPUT AS #1
 i = 0
 DO UNTIL EOF(1)
  i = i + 1
  INPUT #1, lbl$(i), lblX(i), lblY(i), lblC(i), lblM(i)
 LOOP
 CLOSE
END SUB

REM $DYNAMIC
DEFSNG A-Z
SUB LoadMaps (file$)
Future.CLS 0
SetPage Primary%
 CLOSE
 'PRINT file$
 OPEN file$ FOR APPEND AS #1
 IF LOF(1) < 1 THEN
  Future.PRINT 10, 10, "Map file " + file$ + " not found.", 155, 0
  SLEEP
  CLOSE
  'KILL file$
  file$ = "maps\world 1.bd3"
 END IF
 CLOSE
 OPEN file$ FOR INPUT AS #1
 INPUT #1, tileset$
 FOR mapno = 1 TO 100
  map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
  OPEN map$ FOR OUTPUT AS #2
   FOR i = 1 TO 25
    INPUT #1, line$
    PRINT #2, line$
   NEXT i
  CLOSE #2
  
'   Future.LINE 40, 80, 40 + 100, 80, 4, -1
'   Future.LINE 40, 80, 40 + mapno, 80, 2, -1
 NEXT mapno
 CLOSE
IF dmaps = 0 THEN
SetPage 2
      Future.CLS 16
      FOR mapno = 1 TO 100
        map$ = "maps\temps\map" + LTRIM$(STR$(mapno)) + ".tmp"
        CLOSE
        M = M + 40
        OPEN map$ FOR INPUT AS #1
        X = 0
        DO UNTIL EOF(1)
         X = X + 1
         INPUT #1, line$
         FOR i = 1 TO LEN(line$)
          ch$ = MID$(line$, i, 1)
          Future.PSET i + M - 40, X + m2, ASC(ch$)
         NEXT i
       LOOP
       CLOSE
       IF RIGHT$(STR$(mapno), 1) = "0" THEN
        M = 0
        m2 = m2 + 25
       END IF
       SetPage Primary%
     '   Future.LINE 40, 90, 40 + 100, 90, 4, -1
     '   Future.LINE 40, 90, 40 + mapno, 90, 2, -1
       SetPage 2
     NEXT mapno
SetPage Secondary%
END IF
END SUB

DEFINT A-Z
SUB LoadMonsters
 CLOSE
 OPEN "data\monster.dat" FOR RANDOM AS #1
 FOR z = 1 TO 40
  GET #1, , monst(z)
 NEXT z
 CLOSE
END SUB

DEFSNG A-Z
SUB LoadSpr (pic$, Array(), cfrom, cto)
  CLOSE
  Future.CLS 0
  OPEN "sprites\" + pic$ FOR INPUT AS #1
  DO UNTIL EOF(1)
   INPUT #1, X, y, C
   IF C = cfrom THEN C = cto
   Future.PSET X, y, C
  LOOP
  CLOSE #1
  Future.GET 0, 0, 15, 15, Array()
END SUB

SUB LoadTiles
 ViewPage Primary%
 SetPage Primary%
 Future.PRINT 50, 240, "Loading graphics...", 15, 0
 SetPage Secondary%
 Xs% = 14
 Ys% = 14
 Future.LINE 0, 0, Xs% + 2, Ys% + 2, 5, 1
 OPEN "data\" + tileset$ FOR INPUT AS #1
 DO UNTIL EOF(1)
  IF INP(96) = 59 THEN
   CLOSE
   EXIT DO
  END IF
  tileno = tileno + 1
  INPUT #1, tile$
  Future.FILLBOX 0, 0, 72, 72, 0
'  SetPage Primary%
'   Future.FILLBOX 40, 70, 40 + 251, 77, 4
'   Future.FILLBOX 40, 70, 40 + tileno, 77, 2
'  SetPage Secondary%
  IF tile$ = "notex.spr" THEN tile$ = "notex2.spr"
  OPEN "sprites\" + tile$ FOR INPUT AS #2
  DO UNTIL EOF(2)
   INPUT #2, X, y, C
   IF RIGHT$(tile$, 3) = "mdg" THEN C = 15
   IF RIGHT$(tile$, 3) = "ico" THEN EXIT DO
   IF RIGHT$(tile$, 3) = "fac" THEN EXIT DO
   Future.PSET X, y, C
  LOOP
  CLOSE #2
  SELECT CASE tileno
   CASE 1
    Future.GET 0, 0, Xs%, Ys%, grass()
   CASE 2
    Future.GET 0, 0, Xs%, Ys%, dirt()
   CASE 3
    Future.GET 0, 0, Xs%, Ys%, tree()
   CASE 4
    Future.GET 0, 0, Xs%, Ys%, tree2()
   CASE 5
    Future.GET 0, 0, Xs%, Ys%, stump()
   CASE 6
    Future.GET 0, 0, Xs%, Ys%, fire1()
   CASE 7
    Future.GET 0, 0, Xs%, Ys%, fire3()
   CASE 8
    Future.GET 0, 0, Xs%, Ys%, fire3()
   CASE 9
    Future.GET 0, 0, Xs%, Ys%, water()
   CASE 10
    Future.GET 0, 0, Xs%, Ys%, floor()
   CASE 11
    Future.GET 0, 0, Xs%, Ys%, cobble()
   CASE 12
    Future.GET 0, 0, Xs%, Ys%, ffield()
   CASE 13
    Future.GET 0, 0, Xs%, Ys%, brick()
   CASE 14
    Future.GET 0, 0, Xs%, Ys%, grind()
   CASE 15
    Future.GET 0, 0, Xs%, Ys%, flour()
   CASE 16
    Future.GET 0, 0, Xs%, Ys%, rock()
   CASE 17
    Future.GET 0, 0, Xs%, Ys%, furnace()
   CASE 18
    Future.GET 0, 0, Xs%, Ys%, anvil()
   CASE 19
    Future.GET 0, 0, Xs%, Ys%, bench()
   CASE 20
    Future.GET 0, 0, Xs%, Ys%, sign()
   CASE 21
    Future.GET 0, 0, Xs%, Ys%, fishspot()
   CASE 22
    Future.GET 0, 0, Xs%, Ys%, woodwall()
   CASE 23
    Future.GET 0, 0, Xs%, Ys%, grass2()
   CASE 24
    Future.GET 0, 0, Xs%, Ys%, rock2()
   CASE 25
    Future.GET 0, 0, Xs%, Ys%, rockW()
   CASE 26
    Future.GET 0, 0, Xs%, Ys%, tiles()
   CASE 27
    Future.GET 0, 0, Xs%, Ys%, lava()
   CASE 28
    Future.GET 0, 0, Xs%, Ys%, snow()
   CASE 29
    Future.GET 0, 0, Xs%, Ys%, snowtree()
   CASE 30
    Future.GET 0, 0, Xs%, Ys%, rockw2()
   CASE IS > 30
    SELECT CASE RIGHT$(tile$, 3)
     CASE "ico"
      icn = icn + 1
      Future.XMSArrayGet 0, 0, icons%, INT(icn)
     CASE "64x"
      i64 = i64 + 1
      Future.XMSArrayGet 0, 0, size64x%, INT(i64)
     CASE "mdg"
      md = md + 1
      Future.XMSArrayGet 0, 0, mdgs%, INT(md)
     CASE "spi"
      spi = spi + 1
      IF spi = 1 THEN Future.XMSArrayGet 0, 0, sprs%, 0
      Future.XMSArrayGet 0, 0, sprs%, INT(spi)
     CASE "fac"
      fac = fac + 1
      Future.XMSArrayGet 0, 0, handle%, INT(fac)
     CASE ELSE
      ci = ci + 1
      Future.XMSArrayGet 0, 0, csets%, INT(ci)
    END SELECT
  END SELECT
 LOOP
 Future.CLS 0
 SetPage Primary%
 Future.CLS 0
END SUB

REM $STATIC
SUB LoadUDT (path$, wld)
CLOSE
OPEN path$ + "ud" + STR$(wld) + ".udt" FOR RANDOM AS #1
FOR i = 1 TO 100
 GET #1, , unit(i)
NEXT i
FOR i = 1 TO 100
 GET #1, , plot(i)
NEXT i
CLOSE
END SUB

REM $DYNAMIC
DEFINT A-Z
SUB Lpalette
 
     ff = FREEFILE
     OPEN "sprites\cdm.pal" FOR INPUT AS #ff
     INPUT #ff, R, G, B
     DO UNTIL EOF(ff)
      INPUT #ff, R, G, B
      OUT &H3C8, C
      OUT &H3C9, R
      OUT &H3C9, G
      OUT &H3C9, B
      C = C + 1
     LOOP
     CLOSE #ff

END SUB

DEFSNG A-Z
FUNCTION MapGlobalX (map AS INTEGER)
'X = INT((map - 1) / 10) * 10
'X = (map - X) * 40
'MapGlobalX = X - 40
 MapGlobalX = Xscroll%
END FUNCTION

FUNCTION MapGlobalY (map AS INTEGER)
 'MapGlobalY = INT((map - 1) / 10) * 25
 MapGlobalY = Yscroll%
END FUNCTION

SUB MiniDigit (X, y, t$, C)
FOR i = 1 TO LEN(t$)
 ch$ = MID$(t$, i, 1)
 IF ch$ = "0" THEN ch$ = "10"
 IF ch$ = "K" THEN ch$ = "11"
 IF ch$ = "." THEN ch$ = "92"
 IF ch$ = " " THEN ch$ = CHR$(40)
 IF ASC(ch$) > 41 THEN
  IF ASC(ch$) > 63 THEN ch$ = STR$(ASC(ch$) - 65 + 12)
  ch = VAL(ch$)
  IF ch = 92 THEN
   Future.PSET X + (i * 5) + 2, y + 5, 15
  ELSE
   Future.XMSArrayPut X + (i * 5), y + 0, mdgs%, ch + 0
  END IF
 END IF
NEXT i
END SUB

SUB MINPUT (Text$, Init$)
 Text$ = ""
 GOSUB RedrawM
 DO
  jkl$ = INKEY$
  SELECT CASE jkl$
   CASE CHR$(13)
    IF Text$ <> "" THEN MSG Text$
    EXIT DO
   CASE CHR$(27)
    Text$ = ""
    IF Text$ <> "" THEN MSG Text$
    EXIT SUB
   CASE CHR$(0) + "H"
    P = P + 1
    Text$ = msgs$(P)
    GOSUB RedrawM
   CASE CHR$(0) + "P"
    P = P - 1
    IF P <= 0 THEN P = 1
    Text$ = msgs$(P)
    GOSUB RedrawM
   CASE CHR$(8)
    IF Text$ <> "" THEN Text$ = LEFT$(Text$, LEN(Text$) - 1)
    GOSUB RedrawM
   CASE IS <> ""
    Text$ = Text$ + jkl$
    GOSUB RedrawM
  END SELECT
 LOOP
 EXIT SUB
RedrawM:
    Future.FILLBOX 1, 460, 600, 480, 15
    Future.PRINT 10, 460, Init$ + Text$ + "", 0, -1
RETURN
END SUB

SUB MSG (MSG1$)

Future.FILLBOX 1, 375, 600, 479, 7
'Future.BOX 1, 375, 599, 479, 20
'Future.BOX 2, 376, 598, 478, 23
'Future.BOX 3, 377, 597, 477, 26
'Future.BOX 5, 378, 596, 476, 23
'Future.BOX 6, 379, 595, 475, 20
IF MSG1$ <> "" THEN
 FOR i = 20 TO 2 STEP -1
  msgs$(i) = msgs$(i - 1)
 NEXT i
 msgs$(1) = MSG1$
END IF
FOR i = 1 TO 5
 G = i + mscroll
 Future.PRINT 10, 459 - y, msgs$(G), 0, -1
 y = y + 17
NEXT i
'DrawBar


END SUB

SUB Pause
 DO: LOOP UNTIL INKEY$ <> ""
END SUB

DEFINT A-Z
SUB SaveBDT (file2$)
SetPage 2
  IF file2$ <> "" THEN
'   UpdateTempMap (currentmap)
   CLOSE
   OPEN file2$ FOR OUTPUT AS #1
   WRITE #1, tileset$
  FOR mapno = 1 TO 100
    FOR i = 1 + yoff TO 25 + yoff
     line$ = ""
     FOR X = 1 + xoff TO 40 + xoff
      a = Future.POINT(X, i)
      IF a >= 0 AND a < 256 THEN
       C$ = CHR$(a)
      END IF
      line$ = line$ + C$
     NEXT X
     PRINT #1, line$
    NEXT i
    xoff = xoff + 40
    IF RIGHT$(STR$(mapno), 1) = "0" THEN
     ' i was stuck for like ten minutes on the above condition
     'cos i used a left instead of a right!! far ouout
     xoff = 0
     yoff = yoff + 25
    END IF
  NEXT mapno
  END IF
  CLOSE
SetPage Primary%

END SUB

REM $STATIC
DEFSNG A-Z
SUB SaveUDT (path$, wld)
CLOSE
OPEN path$ + "ud" + STR$(wld) + ".udt" FOR RANDOM AS #1
FOR i = 1 TO 100
 IF pname$ = "new_game" THEN
  IF unit(i).Rank <> 19 THEN unit(i).MVT = 0 ELSE unit(i).MVT = 15
 END IF
 IF unit(i).Rank = -1 THEN ' save null unit if rank=-1
  PUT #1, , unit(0)
 ELSE
  PUT #1, , unit(i)
 END IF
NEXT i
FOR i = 1 TO 100
 PUT #1, , plot(i)
NEXT i
CLOSE

END SUB

SUB SelectUnit (X, y)
 FOR i = 1 TO 100'maxunits
  IF unit(i).HP > 0 THEN
   IF unit(i).X = X + Xscroll% THEN
    IF unit(i).y = y + Yscroll% THEN
     SELUNIT% = i
     EXIT FOR
    END IF
   END IF
  END IF
 NEXT i
END SUB

